/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import org.apache.commons.lang.BooleanUtils;

import br.com.rjconsultores.auditador.annotations.AuditarAtributo;
import br.com.rjconsultores.auditador.annotations.AuditarClasse;
import br.com.rjconsultores.auditador.annotations.AuditarLista;
import br.com.rjconsultores.auditador.annotations.NaoAuditar;
import br.com.rjconsultores.auditador.interfaces.Auditavel;

/**
 *
 * @author Rafael
 */
@AuditarClasse(nome = "PtovtaTitular", tela = "auditarClasse.PtovtaTitular")
@Entity
@Table(name = "PTOVTA_TITULAR")
@SequenceGenerator(name = "PTOVTA_TITULAR_SEQ ", sequenceName = "PTOVTA_TITULAR_SEQ ", allocationSize = 1)
public class PtovtaTitular implements Serializable, Auditavel<PtovtaTitular> {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PTOVTA_TITULAR_SEQ ")
    @Column(name = "PTOVTATITULAR_ID")
    private Integer ptovtaTitularId;
   
    @AuditarAtributo(nome = "NOME TITULAR/FOTO")
    @Column(name = "NOME")
    private String nome;
    
    @Column(name = "CPF")
    private String cpf;
   
    @Column(name = "RG")
    private String rg;
    
    @Column(name = "ORGAOEMISSOR")
    private String orgaoemissor;
    @Lob
    @Column(name = "IMAGEM")
    private byte[]  imagem;
    
   
    @Column(name = "ACTIVO")
    private Boolean activo;
   
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
   
    @Column(name = "USUARIO_ID")
    private int usuarioId;  
    
	
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "titularId")
    private List<PuntoVenta> puntoVentaList;
    
    @Transient
	@NaoAuditar
	private PtovtaTitular ptovtaTitularClone;    

    public PtovtaTitular() {
    }

    public PtovtaTitular(Integer ptovtaTitularId) {
        this.ptovtaTitularId = ptovtaTitularId;
    }

    public PtovtaTitular(Integer ptovtaTitularId, String nome, String cpf, String rg, String orgaoemissor, Boolean activo, Date fecmodif, int usuarioId) {
        this.ptovtaTitularId = ptovtaTitularId;
        this.nome = nome;
        this.cpf = cpf;
        this.rg = rg;
        this.orgaoemissor = orgaoemissor;
        this.activo = activo;
        this.fecmodif = fecmodif;
        this.usuarioId = usuarioId;
    }

  

    public Integer getPtovtaTitularId() {
		return ptovtaTitularId;
	}

	public void setPtovtaTitularId(Integer ptovtaTitularId) {
		this.ptovtaTitularId = ptovtaTitularId;
	}

	public String getNome() {
        return nome;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public String getCpf() {
        return cpf;
    }

    public void setCpf(String cpf) {
        this.cpf = cpf;
    }

    public String getRg() {
        return rg;
    }

    public void setRg(String rg) {
        this.rg = rg;
    }

    public String getOrgaoemissor() {
        return orgaoemissor;
    }

    public void setOrgaoemissor(String orgaoemissor) {
        this.orgaoemissor = orgaoemissor;
    }

    public byte[] getImagem() {
        return imagem;
    }

    public void setImagem(byte[] imagem) {
        this.imagem = imagem;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public int getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(int usuarioId) {
        this.usuarioId = usuarioId;
    }

   
    public List<PuntoVenta> getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(List<PuntoVenta> puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	@Override
    public int hashCode() {
        int hash = 0;
        hash += (ptovtaTitularId != null ? ptovtaTitularId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PtovtaTitular)) {
            return false;
        }
        PtovtaTitular other = (PtovtaTitular) object;
        if ((this.ptovtaTitularId == null && other.ptovtaTitularId != null) || (this.ptovtaTitularId != null && !this.ptovtaTitularId.equals(other.ptovtaTitularId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.PtovtaTitular[ ptovtaTitularId=" + ptovtaTitularId + " ]";
    }
    
	@Override
	public void clonar() throws CloneNotSupportedException {
		ptovtaTitularClone = new PtovtaTitular();
		ptovtaTitularClone = (PtovtaTitular) this.clone();
		
		if(this.getPuntoVentaList() != null) {
			List<PuntoVenta> lsClones = new ArrayList<PuntoVenta>();
			for (PuntoVenta puntoVenta : this.getPuntoVentaList()) {
				if(BooleanUtils.isTrue(puntoVenta.getActivo())) {
					puntoVenta.clonar();
					lsClones.add(puntoVenta.getCloneObject());
				}
			}
			ptovtaTitularClone.setPuntoVentaList(lsClones);
		}
		
	}

	@Override
	public PtovtaTitular getCloneObject() throws CloneNotSupportedException {
		return ptovtaTitularClone;
	}

	@Override
	public String getTextoInclusaoExclusao() {
		return String.format("ID [%s]", getPtovtaTitularId());
	}


}
